/* MailTweak internal component - Copyright (C) 2007, 2009 Rod Whiteley - Licensed under the Open Software License version 3.0 - Source at http://mailtweak.mozdev.org/ */
MRU = {
pref: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extension.mailtweak.pending.mru."),pop: null,custom: null,init: function () {
this.pop = document.getElementById("mru").firstChild
var mru = this.pref.getChildList("", {}).sort(function (a, b) {return Number(a) > Number(b)? -1 : 1})
for each (var u in mru) {
var p = this.pref.getCharPref(u), v = this.preset(p)
if (!v) continue
with (this.pop.appendChild(document.createElement("menuitem")))
setAttribute("label", this.prettyText(v)),setAttribute("value", p)}
this.custom = this.pop.appendChild(document.createElement("menuitem"))
this.custom.hidden = true
this.pop.parentNode.value = this.pop.firstChild.value},display: function () {
var m = document.getElementById("mode").value
if (m == 0) t = "u"
else if (m == 1)
t = "nhdwmy".charAt(document.getElementById("unit").value)
+ document.getElementById("delay").value
else t = "@" + Pend.date.getTime()
var i = this.pop.firstChild
while (i) {
if (i.value == t) break
i = i.nextSibling}
if (i) {
this.custom.hidden = true}
else {
this.custom.setAttribute("label", this.prettyText(this.preset(t)))
this.custom.setAttribute("value", t)
this.custom.hidden = false}
document.getElementById("mru").value = t},preset: function (v) {
var m = NaN, u = NaN, d = v.substr(1)
switch (v.charAt(0)) {
case "u": m = 0; break
case "n": u = 0; m = 1; break
case "h": u = 1; m = 1; break
case "d": u = 2; m = 1; break
case "w": u = 3; m = 1; break
case "m": u = 4; m = 1; break
case "y": u = 5; m = 1; break
case "@": m = 2; break
default: return null}
return {mode: m, unit: u, delay: d}},prettyDate: function (n) {
var d = new Date
d.setTime(n)
return d.toLocaleString()},prettyText: function (v) {
var a = [
" minutes", " minute"," hours", " hour"," days", " day"," weeks", " week"," months", " month"," years", " year"
]
return v.mode == 0? "Unsent"
: v.mode == 1? v.delay + a[2 * v.unit + (v.delay == 1? 1 : 0)]
: v.mode == 2? this.prettyDate(v.delay)
: "???"},select: function (elem) {
var t = this.preset(elem.getAttribute("value"))
document.getElementById("mode").value = t.mode
document.getElementById("unit").value = t.mode == 1? t.unit : 2
document.getElementById("delay").value = t.mode == 1? t.delay : 1
ui()
if (t.mode == 1) delayFix()
else if (t.mode == 2) {
var d = new Date
d.setTime(t.delay)
Pend.date = d
dateFix()
hourWas = document.getElementById("hour").value}}}
Pend = {
ampm: true,_date: new Date,get date () {return this._date},set date (d) {
with (this._date) setYear(d.getFullYear()), setMonth(d.getMonth()), setDate(d.getDate()),setHours(d.getHours()), setMinutes(d.getMinutes()), setSeconds(0)
document.getElementById("year").value = this._date.getFullYear()
document.getElementById("month").value = this._date.getMonth() + 1
document.getElementById("day").value = this._date.getDate()
var h = this._date.getHours(), a = h < 12
h = (this.ampm && h == 0)? 12 : (this.ampm && h > 12)? h - 12 : h
document.getElementById("hour").value = h
document.getElementById("ampm").value = a? 0 : 1
document.getElementById("minute").value = this._date.getMinutes()
document.documentElement.getButton("accept").disabled = (d <= new Date)
MRU.display()
return d},_mode: 0,get mode () {return this._mode},set mode (m) {
document.getElementById("mode").value = m
ui()
return this._mode = m}}
accept = function () {
window.arguments[0].value = document.getElementById("mru").value}
onload = function () {
dump(">> load: " + window.arguments[0].info + "\n")
var d = (new Date(1999, 0, 1, 22, 0, 0)).toLocaleTimeString()
Pend.ampm = (d.charAt(0) == "1") || true
document.getElementById("ampm").hidden = !Pend.ampm
MRU.init()
with (document.getElementById("date-picker")) {
init(window)
set(Pend.date)
addEventListener("command", dateSelect, false)}
ui()}
dateSelect = function (event) {
Pend.mode = 2
if (event.detail) Pend.date = new Date(event.detail)}
hourMode = "command"
hourWas = 0
dateFix = function (event) {
var h = Number(document.getElementById("hour").value)
var am = document.getElementById("ampm").value == "0"
if (event && event.target.id.indexOf("ampm") == 0) {
h = Pend.date.getHours() + (am? -12 : 12)}
else if (event && event.target.id == "hour") {
if (Pend.ampm) {
if (hourMode == "command") {
var up = h > 1 && h > hourWas
hourWas = h
h = Pend.date.getHours() + (up? 1 : -1)}
else {
while (h > 12) h -= 12
while (h < 1) h += 12
if (am) {
if (h == 12) h = 0}
else {
if (h < 12) h += 12}}}}
else h = Pend.date.getHours()
Pend.date = new Date(
document.getElementById("year").value,document.getElementById("month").value - 1,document.getElementById("day").value,h,document.getElementById("minute").value,0)
hourWas = document.getElementById("hour").value
document.getElementById("date-picker").set(Pend.date)}
delayFix = function () {
var d = new Date
var n = Number(document.getElementById("delay").value) || 1
switch (document.getElementById("unit").value) {
case "0": 
d.setMinutes(d.getMinutes() + n)
break
case "1": 
d.setHours(d.getHours() + n)
break
case "2": 
d.setDate(d.getDate() + n)
break
case "3": 
d.setDate(d.getDate() + 7 * n)
break
case "4": 
d.setMonth(d.getMonth() + n)
break
case "5": 
d.setYear(d.getFullYear() + n)
break}
Pend.date = d
hourWas = document.getElementById("hour").value
document.getElementById("date-picker").set(Pend.date)}
modeFix = function (event) {
if (event.target.className != "mode") return
ui()
var m = document.getElementById("mode").value
if (m == 0) MRU.display()
else if (m == 1) delayFix()
else if (m == 2) dateFix()}
_input = 0
input = function () {
if (_input) clearTimeout(_input), _input = 0
_input = setTimeout(function () {dateFix({type: "input"}), _input = 0}, 400)}
ui = function () {
var m = document.getElementById("mode").value
var unsent = (m == 0), delay = (m == 1), date = (m == 2)
document.getElementById("delay").disabled = unsent || date
document.getElementById("unit").disabled = unsent || date
document.getElementById("year").disabled = unsent
document.getElementById("month").disabled = unsent
document.getElementById("day").disabled = unsent
document.getElementById("hour").disabled = unsent
document.getElementById("minute").disabled = unsent
var ro = function (id) {
var elem = document.getElementById(id)
elem[delay? "setAttribute":"removeAttribute"]("readonly", "true")
elem.spinButtons.disabled = delay}
ro("year"), ro("month"), ro("day"), ro("hour"), ro("minute")
var elem = document.getElementById("ampm")
elem[delay? "setAttribute":"removeAttribute"]("readonly", "true")
elem.childNodes[elem.value ^ 1].disabled = delay}
